<?php

if (session_id() == "")
{
/* session not started */
session_start();
}

// Set the content-type
header("Content-type: image/png");

// ------------Captcha Image Config------------
$font = 'comic.ttf'; 
$possible_code = "23456789abcdefghijkmnpqrstuvwxyz";
$code = "";
$num_character = isset($_GET['num_character']) ? $_GET['num_character'] : 6;
$width = isset($_GET['width']) ? $_GET['width'] : 250;
$height = isset($_GET['height']) ? $_GET['height'] : 40;
$font_size = $height * 0.6;
$font_space_x = $width/20;
$font_space_y = $height/30;
$max_angle = 50; 

// 0 = false, 1 = true
$open_shadow = 1;
$open_angle = 1;
$open_bg_image = 0;
$link_bg_image = "bg.gif";
$open_random_line = 0;
$open_random_bg_word = 1;
$max_random_bg_word = 30;
$open_white_grid = 1;
$open_white_grid_row = 1;
$open_white_grid_col = 0;


// Create the image
$im = imagecreatetruecolor($width, $height);

// Create some colors
$white = imagecolorallocate($im, 255, 255, 255);
$grey = imagecolorallocate($im, 128, 128, 128);
$black = imagecolorallocate($im, 0, 0, 0);


imagefilledrectangle($im, 0, 0, $width, $height, $white);

// gen the code 
for ($i =0; $i < $num_character; $i ++) {
	$code .= substr($possible_code,mt_rand(0,strlen($possible_code)-1),1); 
}

// draw background 
if ($open_bg_image == true){
	if($link_bg_image != null){
		$bgdat = getimagesize($link_bg_image);
	  if($bgdat == true){
		  /*
		  Array[0] = Width
			Array[1] = Height
			Array[2] = Image Type Flag
			Array[3] = width="xxx" height="xxx"
			Array[bits] = bits (PHP >= 4.3.0)
			Array[channels] = channels (PHP >= 4.3.0)
			Array[mime] = mime-type (PHP >= 4.3.0)
		  */
			switch($bgdat[2]) {
				/*
				1 => 'GIF',
	      2 => 'JPG',
	      3 => 'PNG',
	      4 => 'SWF',
	      5 => 'PSD',
	      6 => 'BMP',
	      7 => 'TIFF(intel byte order)',
	      8 => 'TIFF(motorola byte order)',
	      9 => 'JPC',
	      10 => 'JP2',
	      11 => 'JPX',
	      12 => 'JB2',
	      13 => 'SWC',
	      14 => 'IFF',
	      15 => 'WBMP',
	      16 => 'XBM'
				*/
			  case 1: $bgimage = imagecreatefromgif($link_bg_image); break;
			  case 2: $bgimage = imagecreatefromjpeg($link_bg_image); break;
			  case 3: $bgimage= imagecreatefrompng($link_bg_image); break;
			  default: break;
		  }
		 if ($bgimage)
		 	 //imagecopy ( resource dst_im, resource src_im, int dst_x, int dst_y, int src_x, int src_y, int src_w, int src_h 
		   imagecopy($im, $bgimage, 0, 0, 0, 0, $width, $height);
	  }
	}
}

// draw random letter
// Create the temp image
if ($open_random_bg_word == true){
	$im2 = imagecreatetruecolor($width, $height);

	imagefilledrectangle($im2, 0, 0, $width, $height, $white);
	for($j =0; $j <$max_random_bg_word; $j ++){
		
		$bg_word = substr($possible_code,mt_rand(0,strlen($possible_code)-1),1);
		
		$bg_word_color = imagecolorallocate($im, mt_rand(200,255), mt_rand(200,255), mt_rand(200,255));
		
		$r_x = mt_rand (0,$width);
		$r_y = mt_rand (0,$height);
		$r_angle = mt_rand(0,360);
		$r_font_size = mt_rand($font_size-$font_size/2,$font_size+$font_size/2);
		
		imagettftext($im2, $r_font_size, $r_angle, $r_x, $r_y, $bg_word_color, $font, $bg_word);
	}
	
	ImageAlphaBlending($im, true);
	imagealphablending($im2, true);
	
	$w = ImageSX($im);
	$h = ImageSY($im);
	
	ImageCopy($im, $im2, 0, 0, 0, 0, $w, $h);
	
	imagedestroy($im2);
}

// draw random bg line

if ($open_random_line == true){
	for ($i =0; $i < $width /5; $i ++){
		$line_color = imagecolorallocate($im, mt_rand(150,255), mt_rand(150,255), mt_rand(150,255));
		imageline($im,mt_rand(0,$width),mt_rand(0,$height),mt_rand(0,$width),mt_rand(0,$height),$line_color);
	}
}

$x = ($font_size + $font_space_x) /2;
$y = 0;
$angle = 0;

// Draw one word per one time
for ($i =0; $i < strlen($code); $i ++){
	
	$text_color = imagecolorallocate($im, mt_rand(0,180), mt_rand(0,180), mt_rand(0,180));
	
	// random word angle
	if ($open_angle == true)
		$angle = mt_rand(-$max_angle,$max_angle);
	
	$y = $font_size + $font_space_y;
	 
	// Add some shadow to the text
	if ($open_shadow == true)
		imagettftext($im, $font_size, $angle, $x +1, $y +1, $grey, $font, $code{$i});
	// Add the text
	imagettftext($im, $font_size, $angle, $x, $y, $text_color, $font, $code{$i});
	
	$x += $font_size + $font_space_x;	
	
}

// draw white grid
if ($open_white_grid == true){
	if ($open_white_grid_row == true){
		// row
		for ($i =0; $i < $height /6; $i ++){
			imageline($im,0,$i * 6,$width,$i * 6,$white);
		}
	}
	if ($open_white_grid_col == true){
		// col 
		for ($j =0; $j < $width /10; $j ++){
			imageline($im,$j * 10,0,$j * 10,$height,$white);
		}
	}
}

	

// Using imagepng() results in clearer text compared with imagejpeg()
imagepng($im);
imagedestroy($im);

$_SESSION['session_security_code'] = $code;
?> 


