function disableAll()
{
    document.getElementById('tab_add').className = 'tab';
    document.getElementById('tab_edit').className = 'tab';
    document.getElementById('tab_view').className = 'tab';

    with( document.cartform ) {
        mode.value = '';

        description.value = '';
        description.disabled = true;
        description.style.background = '#DDDDDD';
        price.value = '';
        price.disabled = true;
        price.style.background = '#DDDDDD';
        plan.selectedIndex = -1;
        plan.disabled = true;
        plan.style.background = '#DDDDDD';
        existing_description.selectedIndex = -1;
        existing_description.disabled = true;
        existing_description.style.background = '#DDDDDD';

        recurring_enable.disabled = true;
        recurring_enable.checked = false;
        recurring_enable.value = 0;
        interval.disabled = true;
        interval.value = '';
        interval.style.background = '#DDDDDD';
        interval_unit.disabled = true;
        interval_unit.style.background = '#DDDDDD';
        recurring_method[0].disabled = true;
        recurring_method[1].disabled = true;
        fixed_number.disabled = true;
        fixed_number.value = '';
        fixed_number.style.background = '#DDDDDD';
    }

    var seg=document.getElementsByName('segment[]');
    for (i=0; i<seg.length; i++)
    {
        seg[i].checked = false;
        seg[i].disabled = true;
    }
}

function onAdd()
{
    if( document.cartform.mode.value != 'add' )
    {
        document.getElementById('tab_add').className = 'tabselected';
        document.getElementById('tab_edit').className = 'tab';
        document.getElementById('tab_view').className = 'tab';
        with( document.cartform )
        {
            mode.value = 'add';

            description.value = '';
            description.disabled = false;
            description.style.background = '#FFFFFF';
            price.value = '';
            price.disabled = false;
            price.style.background = '#FFFFFF';
            plan.selectedIndex = 0;
            plan.disabled = false;
            plan.style.background = '#FFFFFF';
            existing_description.selectedIndex = -1;
            existing_description.disabled = true;
            existing_description.style.background = '#DDDDDD';

            recurring_enable.disabled = false;
            recurring_enable.checked = false;
            recurring_enable.value = 0;
            interval.disabled = true;
            interval.value = '';
            interval.style.background = '#DDDDDD';
            interval_unit.disabled = true;
            interval_unit.style.background = '#DDDDDD';
            recurring_method[0].disabled = true;
            recurring_method[1].disabled = true;
            fixed_number.disabled = true;
            fixed_number.value = '';
            fixed_number.style.background = '#DDDDDD';
        }
        var seg=document.getElementsByName('segment[]');
        if(seg.length == 1) {   // no multiple segment
            seg[0].checked = false;
            seg[0].disabled = true;
        }
        else {
            for (i=0; i<seg.length; i++) {
                seg[i].checked = false;
                seg[i].disabled = false;
            }
        }
    }
    else
        disableAll();
}

function onEdit()
{
    if( document.cartform.mode.value != 'edit' )
    {
        document.getElementById('tab_add').className = 'tab';
        document.getElementById('tab_edit').className = 'tabselected';
        document.getElementById('tab_view').className = 'tab';
        with( document.cartform )
        {
            mode.value = 'edit';

	    // 20070713 - disable editing of description field
            description.value = '';
            description.disabled = true;
            description.style.background = '#DDDDDD';
            price.value = '';
            price.disabled = false;
            price.style.background = '#FFFFFF';
            plan.selectedIndex = -1;
            plan.disabled = false;
            plan.style.background = '#FFFFFF';
            existing_description.selectedIndex = -1;
            existing_description.disabled = false;
            existing_description.style.background = '#FFFFFF';

            recurring_enable.disabled = false;
            recurring_enable.checked = false;
            recurring_enable.value = 0;
            interval.disabled = true;
            interval.value = '';
            interval.style.background = '#DDDDDD';
            interval_unit.disabled = true;
            interval_unit.style.background = '#DDDDDD';
            recurring_method[0].disabled = true;
            recurring_method[1].disabled = true;
            fixed_number.disabled = true;
            fixed_number.value = '';
            fixed_number.style.background = '#DDDDDD';
        }
        var seg=document.getElementsByName('segment[]');
        if(seg.length == 1)  {  // no multiple segment
            seg[0].checked = false;
            seg[0].disabled = true;
        }
        else {
            for (i=0; i<seg.length; i++) {
                seg[i].checked = false;
                seg[i].disabled = false;
            }          
        }
    }
    else
        disableAll();
}
function onView()
{
    if( document.cartform.mode.value != 'edit' )
    {
        document.getElementById('tab_add').className = 'tab';
        document.getElementById('tab_edit').className = 'tab';
        document.getElementById('tab_view').className = 'tabselected';
        with( document.cartform )
        {
            mode.value = 'view';

            description.value = '';
            description.disabled = true;
            description.style.background = '#DDDDDD';
            price.value = '';
            price.disabled = true;
            price.style.background = '#DDDDDD';
            plan.selectedIndex = -1;
            plan.disabled = true;
            plan.style.background = '#DDDDDD';
            existing_description.selectedIndex = 0;
            existing_description.disabled = false;
            existing_description.style.background = '#FFFFFF';

            recurring_enable.disabled = true;
            recurring_enable.checked = true;
            recurring_enable.value = 0;
            interval.disabled = true;
            interval.value = '';
            interval.style.background = '#DDDDDD';
            interval_unit.disabled = true;
            interval_unit.style.background = '#DDDDDD';
            recurring_method[0].disabled = true;
            recurring_method[1].disabled = true;
            fixed_number.disabled = true;
            fixed_number.value = '';
            fixed_number.style.background = '#DDDDDD';
            if(existing_description.options[0])
                onSelectBox(existing_description);

        }
        var seg=document.getElementsByName('segment[]');
        if(seg.length == 1)  {  // no multiple segment
            seg[0].checked = false;
            seg[0].disabled = true;
        }
        else {
            for (i=0; i<seg.length; i++) {
                seg[i].checked = false;
                seg[i].disabled = true;
            }          
        }

    }
    else
        disableAll();
}

function onDelete()
{
    if( document.cartform.mode.value != 'del' )
    {
        document.cartform.mode.value = 'del';
        document.cartform.submit();
    }
    else
        disableAll();
}

function displayInfo(description, price, plan, recurring_enable, interval, interval_unit, recurring_method, fixed_number, segment_ip)
{
    var seg_array = segment_ip.split(",");
    var oForm = document.cartform;

    oForm.description.value = description;
    oForm.price.value = price;
    oForm.plan.value = plan;
    oForm.recurring_enable.value = recurring_enable;
    oForm.interval.value = interval;
    oForm.interval_unit.value = interval_unit;

    if (interval_unit == 'days')
        oForm.interval_unit.selectedIndex = 0;
    else if (interval_unit == 'weeks')
        oForm.interval_unit.selectedIndex = 1;
    else if (interval_unit == 'months')
        oForm.interval_unit.selectedIndex = 2;
    else if (interval_unit == 'years')
        oForm.interval_unit.selectedIndex = 3;
    oForm.recurring_method.value = recurring_method;
    oForm.fixed_number.value = fixed_number;

    if (recurring_method == 'infinite')
        oForm.recurring_method[0].checked = true;
    else if (recurring_method == 'fixed')
        oForm.recurring_method[1].checked = true;
    else
        oForm.recurring_method[0].checked = true;

    if (recurring_enable == '0')
    {
        oForm.recurring_enable.checked = false;
        oForm.interval.disabled = true;
        oForm.interval.style.background = '#DDDDDD';
        oForm.interval_unit.disabled = true;
        oForm.interval_unit.style.background = '#DDDDDD';
        oForm.recurring_method[0].disabled = true;
        oForm.recurring_method[1].disabled = true;
        oForm.fixed_number.disabled = true;
        oForm.fixed_number.style.background = '#DDDDDD';
    }
    else
    {
        oForm.recurring_enable.checked = true;
        if (oForm.mode.value == 'edit' )
        {
            oForm.interval.disabled = false;
            oForm.interval.style.background = '#FFFFFF';
            oForm.interval_unit.disabled = false;
            oForm.interval_unit.style.background = '#FFFFFF';
            oForm.recurring_method[0].disabled = false;
            oForm.recurring_method[1].disabled = false;
            oForm.fixed_number.disabled = false;
            oForm.fixed_number.style.background = '#FFFFFF';
        }
    }

    var seg=document.getElementsByName('segment[]');
    //clear all chechbox
    for(y=0; y<seg.length;y++)
    {
        seg[y].checked = false;
    }
    if(seg_array[0] != '*')
    {
        if(seg_array[0]=='') {  //cart for all segments
            if(seg.length == 1)
                seg.checked = true;
            else
                seg[0].checked = true;
        }
        else
        {
            for(i=0;i<seg_array.length;i++)
            {
                if(seg_array[i]!='')
                    seg[parseInt(seg_array[i])+1].checked = true;
            }
        }
    }
}

function onRecurrEnable()
{
    with( document.cartform )
    {
        if (recurring_enable.checked == true)
        {
            recurring_enable.value = 1;
            interval.disabled = false;
            interval.style.background = '#FFFFFF';
            interval_unit.disabled = false;
            interval_unit.style.background = '#FFFFFF';
            recurring_method[0].disabled = false;
            recurring_method[1].disabled = false;
            fixed_number.disabled = false;
            fixed_number.style.background = '#FFFFFF';
        }
        else
        {
            recurring_enable.value = 0;
            interval.disabled = true;
            interval.value = '';
            interval.style.background = '#DDDDDD';
            interval_unit.disabled = true;
            interval_unit.style.background = '#DDDDDD';
            recurring_method[0].disabled = true;
            recurring_method[1].disabled = true;
            fixed_number.disabled = true;
            fixed_number.style.background = '#DDDDDD';
            fixed_number.value = '';
        }
    }
}

function onSelectRecurring()
{
    if (document.cartform.infinite.checked == true)
        document.cartform.fixed.checked = false;
    else
        document.cartform.fixed.checked = true;
}
