<?php
include_once("..\\authserv\\common_functions.php");

// create COM object
$settingobj = new COM("FSCONFIG.Cfgmgr") or die("user_status.php FSCONFIG.Cfgmgr Object cannot be created!");
$useRADIUS = $settingobj->getKey( "use_radius", "radius" );

if( strcasecmp( $useRADIUS, "true" )==0 ){
    exit(); // not handle when using RADIUS
}else{
    $dsn_file = $settingobj->getKey( "Datasource", "gateway");
}
$session_handling = $settingobj->getKey( "session_handling", "gateway");
$dsn_source=fopen($dsn_file, "r") or die("Cannot open DSN source file!");
$secret_enable = $settingobj->getKey( "secret_enable", "gateway");

$curr_siteID="";

//* scenario2 and load balancing: same layout, different text 
$isScenario2 = $settingobj->getKey('scenario2', 'gateway');
$FOMode=$settingobj->getKey('mode', 'FSFO');

if($FOMode == 3)
	$enableLoadBalancing=1;
else
	$enableLoadBalancing=0;
	
if ($isScenario2 || $enableLoadBalancing){
	
	if ($enableLoadBalancing)
		$curr_siteID = $settingobj->getKey('MachineID', 'FSFO');
	else
		$curr_siteID = $settingobj->getKey('siteID', 'gateway');
}else{
	// not handle non- scenario2 or load balancing
	exit();
}
$dsn="";

if(!feof($dsn_source))
{
    $line=fgets($dsn_source,512);
}

while (!feof($dsn_source))
{
    $line=fgets($dsn_source,512);
    if (trim($line)!="")
        $dsn=$dsn.$line;
}
$dsn=str_replace("\r\n",";",$dsn);
$userDB=odbc_connect($dsn,"","");

// Current FirstSpot user info (SiteID / MachineID)
if ($userDB) 
{
    $firstspotusertable=$settingobj->getKey( "Datasource_Tablename", "gateway");
	
    // get the size
	$query="SELECT COUNT(*) AS num FROM $firstspotusertable WHERE reserved1 IS NOT NULL AND SITEID = \"".$curr_siteID."\" ;";
	$result = odbc_exec( $userDB, $query );
	$ArraySize = odbc_result( $result, 'num' );
    
	$query="SELECT * FROM $firstspotusertable WHERE reserved1 IS NOT NULL AND SITEID = \"".$curr_siteID."\" ORDER BY NAME ;";

    $result=odbc_exec($userDB,$query);
    $group="";
    $ipmapExists = false;
    $count=0;
    // Two-dimensional Arrays
    ?>
    	var updateUserInfo = new Array(<?=$ArraySize?>);
    <?
    while (odbc_fetch_row($result)) 
    {
        $login_Time = "";
        $duration = "";
        $timeDiff = ""; // durication in sec format
        $name=odbc_result($result,"name");
        $address=odbc_result($result,"reserved1");
        $logintime=odbc_result($result,"reserved2");
        $ipAddr=odbc_result($result,"reserved5");
		
		//To Control the display of the data traffic
		$bwcount=odbc_result($result,'bwcount');
		$bwcountUL=odbc_result($result,'bwcountUL');
		$bwcountSHA=odbc_result($result,'bwcountSHA');
		
		if( $isScenario2 || $enableLoadBalancing)
			$siteID = odbc_result($result, "siteID");
		
		if( strcasecmp( $useRADIUS, "true" )!=0 )
			$group = odbc_result($result, "groupname");
        $realname=$name;
        $title="";
        if( strstr( $name, "anonymous_" )!=NULL )
            $name = "*Anonymous";

        if ( strlen($name) > 25 ) {
            $title = " title=\"".$name."\"";
            $name = substr($name, 0, 25)."...";
        }

        // consider whether the long value of the result
        // is equal or larger than (2 to power 33)-1

        $mac_str = "";
        $IP_str = "";
        
        // use to specify this user from other site
    	$endStr="";
    	
    	$login_Time = date("D M d H:i:s Y", $logintime);
    	
        if ((!$isScenario2 && !$enableLoadBalancing) || (strcasecmp( $siteID, $curr_siteID )==0)){
	        if($session_handling==0)
	        {
	            $mac_base = true;
	            $mac_str=make_mac_name($address);
	            
	            if($ipAddr!=null || $ipAddr!=0){
	            	$IP_str=long2ip($ipAddr);
	            	$ip = explode(".",$IP_str);
	            	$IP_str=$ip[3].".".$ip[2].".".$ip[1].".".$ip[0];
	        	}
	        } 
	        else
	        {
	            $mac_base = false;
	            $IP_str=long2ip($address);  
	
	            // since the bytes of this ip is inverted, we need to reformat it
	            $ip = explode(".",$IP_str);
	
	            $IP_str=$ip[3].".".$ip[2].".".$ip[1].".".$ip[0];
	        }
	        
	        if($IP_str!="")
	        {
		        $ipmaplogpath = realpath("..\\log\\ipmap.log");
		        if (file_exists($ipmaplogpath)) {
			        $value = $settingobj->ReadINI("addrmap", $IP_str, $ipmaplogpath);
			        if($value!=0) {
				    	$IP_str .= "<br><font color='blue'> -> ".$value."</font>";
				    	$ipmapExists = true;
			        }
	        	}
	        }
	        
	        
	        // reserved5 field is empty, do... 
	        if($ipmapExists != true){
		        $filename="..\\dhcp\\dhcpservice.ini";
		        $fp = fopen($filename,"r");
		        while(!feof($fp))
		        {
		            $line = fgets($fp);
		            if (strcmp(substr($line, 0, 1), "[") == 0) {
		                $temp_mac = substr($line, 1, strlen($line)-4);
		                if ($mac_base == true) {
		                    if (strcmp($mac_str, $temp_mac) == 0) {
		                        if (!feof($fp)) {
		                            $line = fgets($fp);
		                            $IP_str = substr($line, 7, -2);
		                            break;
		                        }
		                    }
		                }
		                else {
		                    if (!feof($fp)) {
		                        $line = fgets($fp);
		                        $temp_IP = substr($line, 7, -2);
		                        if (strcmp($IP_str, $temp_IP) == 0) {
					    // 20080225 - Hide the string of unknown MAC
					    if (strncmp($temp_mac, "UNKNOWN", 7) == 0) {
						$mac_str = "";
					    } else {
						$mac_str = $temp_mac;
					    }
		                            break;
		                        }
		                    }
		                }
		            }
		        }
		        fclose($fp);
		    }
		    // calculate elapsed time (in seconds!)
		    $diff = time()-$logintime;
		    
		    $timeDiff = $diff; // durication in sec format
		    
		    $daysDiff = floor($diff/60/60/24);
		    $diff -= $daysDiff*60*60*24;
		    $hrsDiff = floor($diff/60/60);
		    $diff -= $hrsDiff*60*60;
		    $minsDiff = floor($diff/60);
		    $diff -= $minsDiff*60;
		    $secsDiff = $diff;
		    
		    // calculate escaped time (current time-login time)
	        $duration = $daysDiff.'d '.$hrsDiff.'h '.$minsDiff.'m '.$secsDiff.'s';
	        
	    }else{
		    // in normal, it wont be occur 
	    }

		//Display the data traffic of of every users
		$myobj = new COM('FSAUTH.Authserv') or die('info.php FSAUTH.Authserv object cannot be created!');
		$bwUseAll=$myobj->QueryBW($address);        
		list($bwUse, $bwUseUL,$bwUseSHA) = split('[,]', $bwUseAll);
		
		$bw_UseSHA="";
		$bw_Use="";
		
		if ($bwcountSHA == 1 || $bwcountSHA==2)
		{
			if ($bwUseSHA<1024)
				$bw_UseSHA = $bwUseSHA."KB";
			else if ($bwUseSHA<1048576)
				$bw_UseSHA = round($bwUseSHA/1024,2)."MB";
			else 
				$bw_UseSHA = round($bwUseSHA/1048576,2)."GB";
			
			$bw_UseUL = "(Total)";
			
		}
		
		else if (($bwcountUL == 1||$bwcountUL == 2) && ($bwcount == 0 || $bwcount == -1) )
		{
			$bw_Use="NA";
			if ($bwUseUL<1024)
				$bw_UseUL = $bwUseUL."KB";
			else if ($bwUseUL<1048576)
				$bw_UseUL = round($bwUseUL/1024,2)."MB";
			else 
				$bw_UseUL = round($bwUseUL/1048576,2)."GB";
			
		}
		
		else if (($bwcount == 1||$bwcount == 2) && ($bwcountUL == 0 || $bwcountUL == -1) )
		{
			$bw_UseUL="NA";
			// 20080128 - Typo (bwUseUL->bwUse)
			if ($bwUse<1024)
				$bw_Use = $bwUse."KB";
			else if ($bwUse<1048576)
				$bw_Use = round($bwUse/1024,2)."MB";
			else 
				$bw_Use = round($bwUse/1048576,2)."GB";
			
		}
		
		else if (($bwcountUL == 1||$bwcountUL == 2) && ($bwcount == 1 || $bwcount == 2) )
		{

			if ($bwUseUL<1024)
				$bw_UseUL = $bwUseUL."KB";
			else if ($bwUseUL<1048576)
				$bw_UseUL = round($bwUseUL/1024,2)."MB";
			else 
				$bw_UseUL = round($bwUseUL/1048576,2)."GB";
				
			if ($bwUse<1024)
				$bw_Use = $bwUse."KB";
			else if ($bwUse<1048576)
				$bw_Use = round($bwUse/1024,2)."MB";
			else 
				$bw_Use = round($bwUse/1048576,2)."GB";
			
		}
		
		else if (($bwcountUL == -1||$bwcountUL == 0) && ($bwcount == -1 || $bwcount == 0) )
		{

			$bw_UseUL ="NA";
			$bw_Use = "NA";
			
		}
		
		else 
		{
			$bw_UseUL ="NA";
			$bw_Use = "NA";
			
		}
			
		//$myObj->Release();
		$myobj=null;
		
		// text field information
		?>
		updateUserInfo[<?=$count?>] = new Array(15);
		updateUserInfo[<?=$count?>][0] = "<?=$realname."|".$curr_siteID?>";
		updateUserInfo[<?=$count?>][1] = "<?=$name?>";
		updateUserInfo[<?=$count?>][2] = "<?=$mac_str?>";
		updateUserInfo[<?=$count?>][3] = "<?=$IP_str?>";
		updateUserInfo[<?=$count?>][4] = "<?=$login_Time?>";
		updateUserInfo[<?=$count?>][5] = "<?=$duration?>";
		updateUserInfo[<?=$count?>][6] = "<?=$bw_Use?>";
		updateUserInfo[<?=$count?>][7] = "<?=$bw_UseUL?>";
		updateUserInfo[<?=$count?>][8] = "<?=$bw_UseSHA?>";
		updateUserInfo[<?=$count?>][9] = "<?=$siteID?>";
		
		<?php
		// attribute information 
		?>
		updateUserInfo[<?=$count?>][10] = "<?=$group?>";
		updateUserInfo[<?=$count?>][11] = "<?=round($logintime)?>";
		updateUserInfo[<?=$count?>][12] = "<?=$bwUse?>";
		updateUserInfo[<?=$count?>][13] = "<?=$bwUseUL?>";
		updateUserInfo[<?=$count?>][14] = "<?=$timeDiff?>";

		<?
		$count++;
		
	} //end looping through all online users
    
    odbc_close($userDB);
    
    if ($ipmapExists){
	    echo "	parent.window.frames.usersHeaderFrame.document.getElementById('publicIPtitle').style.display='';"; // usersHeaderFrame iframe's name in c_Sstatus.php
    }
    
    // update field 
    // this function in user_status.php
    ?>
    updateFiled(); 
    <?
}else{
	exit();
}

?>
